<?php
namespace App\Model;



use  Nette\Database\Context;

class MujModel extends \Nette\Object
{

    /** @var Nette\Database\Context */
    private $database;
    protected $table;
    
    private $graf_id = 1;
    private $graf_column = 'celkovy_vh';

    public function __construct(\Nette\Database\Context $database) {
        $this->database = $database;
    }
    
    public function setGrafId($id) {
        $this->graf_id = $id;
    }
    
    public function setGrafColumn($column){
        $this->graf_column = $column;
    }
    public function getGrafColumn(){
        return $this->graf_column;
    }
    public function getGrafData(){
        //$pokus = $this->graf_column;
        //dump($pokus);
        return $this->getTable('ekonomicke_udaje')
                ->select(
                        'firmy.nazev AS nazev, obdobi,'
                        .$this->graf_column.' AS hodnota')
                ->order('obdobi ASC')->where('firmy.id = ?', $this->graf_id);
     
    }    
    

    public function getTable($table){
        return $this->database->table($table);
    }

    public function getKontaktySelection($firmy_id){       
        return $this->database->table('kontakty')
            ->select('kontakty.id, kontakt, poznamka, firmy_id, firmy.nazev, typy_kontaktu.typ')
            ->where('firmy_id = ?', $firmy_id);

    } 
    
    public function getPobockySelection($firmy_id){
        return $this->database->table('pobocky')
            ->select('pobocky.id,pobocky.mesto, pobocky.ulice, pobocky.cislo_popisne,
                    pobocky.psc, pobocky.nazev, pobocky.komentar')
            ->where('firmy_id = ?', $firmy_id);
    }
    
    public function getSpolecniciSelection($firmy_id){
        return $this->database->table('spolecnici')
            ->select('spolecnici.id, osoba, podil, pozice, dalsi_firmy')
            ->where('firmy_id = ?', $firmy_id);
    }
    
    public function findAll()
    {
           return $this->database->query('SELECT * FROM firmy order by `id`');
    }
    
    public function findAllTypKontakt(){
        return $this->database->query('SELECT * FROM typy_kontaktu order by id' );
    }
    
    public function getFirma($id)
{
    return $this->database->table('firmy')->where('id', $id);
}
	    
    public function getNazvySloupcu(){
    
        $cols = $this->database->getConnection()->getSupplementalDriver()->getColumns('ekonomicke_udaje');
        //dump($cols);
        return $cols;

    }
    
    
    
    
}   



